
import std.thread;
import concurrent.all;

extern (C) int sleep(uint seconds);

int
main()
{
/*
  Mutex t1 = new Mutex();
  Semaphore t2 = new Semaphore(10);
  FairSemaphore t3 = new FairSemaphore(10);
  FIFOSemaphore t4 = new FIFOSemaphore(10);
  ReentrantLock t5 = new ReentrantLock();
  Latch t6 = new Latch();
  CountDown t7 = new CountDown(10);
*/

	Object x = new BoundedLinkedQueue!(wrap!(int))(5);
	Channel!(wrap!(int)) queue = cast(BoundedChannel!(wrap!(int)))x;

	int count = 10;

	int producer()
	{
		for (int i=0;i<count;i++)
		{
			queue.put(new wrap!(int)(i));
			printf("put: %d\n", i);
		}
		return 0;
	}

	int consumer() {
		for (int i=0; i<count; i++)
		{
			wrap!(int) x = queue.take();
			assert(x!== null);
			int j = x.value;
			printf("took: %d\n", j);
			sleep(1);
		}
		return 0;
	}

	Thread producerThread = new Thread(&producer);
	Thread consumerThread = new Thread(&consumer);

	producerThread.start();
	consumerThread.start();

	producerThread.wait();
	consumerThread.wait();

  return 0;
}
