#DFLAGS=-O -release
DFLAGS=-unittest -g

CC=sc
#DMD=\dmd\bin\dmd
DMD=dmd.exe


OBJS = sync.obj semaphore.obj fairsemaphore.obj mutex.obj waitnotify.obj \
	waitnotifyimpl.obj queuedsemaphore.obj fifosemaphore.obj \
	reentrantlock.obj latch.obj barrier.obj rendezvous.obj \
	countdown.obj cyclicbarrier.obj

targets : unittest.exe
	.\unittest.exe

unittest.exe : concurrent\unittest.d concurrent.lib
	$(DMD) concurrent\unittest.d -g concurrent.lib
	sc unittest.obj -g concurrent.lib

concurrent.lib : $(OBJS)
	lib -c concurrent.lib $(OBJS)

clean:
	del $(OBJS)

sync.obj : concurrent\sync.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
semaphore.obj : concurrent\semaphore.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
fairsemaphore.obj : concurrent\fairsemaphore.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
queuedsemaphore.obj : concurrent\queuedsemaphore.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
fifosemaphore.obj : concurrent\fifosemaphore.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
mutex.obj : concurrent\mutex.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
waitnotify.obj : concurrent\waitnotify.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
waitnotifyimpl.obj : concurrent\waitnotifyimpl.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
reentrantlock.obj : concurrent/reentrantlock.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
latch.obj : concurrent/latch.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
countdown.obj : concurrent/countdown.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
barrier.obj : concurrent/barrier.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
cyclicbarrier.obj : concurrent/cyclicbarrier.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
rendezvous.obj : concurrent/rendezvous.d
	$(DMD) -c $(DFLAGS) concurrent\$<d
